=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-01-07 17:46:25 +0000
+++ bzrlib/osutils.py	2010-01-13 15:30:22 +0000
@@ -205,12 +205,14 @@
     :param unlink_func: A way to delete the target file if the full rename
         succeeds
     """
-    new = safe_unicode(new)
     # sftp rename doesn't allow overwriting, so play tricks:
     base = os.path.basename(new)
     dirname = os.path.dirname(new)
-    tmp_name = u'tmp.%s.%.9f.%d.%s' % (base, time.time(),
-                                       os.getpid(), rand_chars(10))
+    # callers use different encodings for the paths so the following MUST
+    # respect that. We rely on python upcasting to unicode if new is unicode
+    # and keeping a str if not.
+    tmp_name = 'tmp.%s.%.9f.%d.%s' % (base, time.time(),
+                                      os.getpid(), rand_chars(10))
     tmp_name = pathjoin(dirname, tmp_name)
 
     # Rename the file out of the way, but keep track if it didn't exist

=== modified file 'bzrlib/tests/ftp_server/pyftpdlib_based.py'
--- bzrlib/tests/ftp_server/pyftpdlib_based.py	2010-01-08 03:35:09 +0000
+++ bzrlib/tests/ftp_server/pyftpdlib_based.py	2010-01-13 15:30:22 +0000
@@ -53,7 +53,7 @@
         return [osutils.safe_utf8(s) for s in os.listdir(path)]
 
     def fs2ftp(self, fspath):
-        p = ftpserver.AbstractedFS.fs2ftp(self, fspath)
+        p = ftpserver.AbstractedFS.fs2ftp(self, osutils.safe_unicode(fspath))
         return osutils.safe_utf8(p)
 
     def ftp2fs(self, ftppath):

